;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; INIT and MAIN JSL targets
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    print "INIT ",pc
                    RTL

                    print "MAIN ",pc
					PHB
					PHK
					PLB
					LDA	$7FFFFF
					BEQ	IntRt
					LDA	$71
					CMP	#$05
					BEQ	EnterPipe
					CMP	#$06
					BEQ	EnterPipe
					CMP	#$0D
					BEQ	EnterPipe
					CMP	#$00
					BNE	FrameLock
					JSR	FrameCount
					JSR	Leak
					JSR	L2Scroll
FrameLock:			JSR L2Fix
EndRt:				PLB
					RTL
IntRt:				LDA	#$01
					STA	$7FFFFF
					PLB
					RTL
EnterPipe:			LDA	$89
					CMP	#$04
					BCS	FrameLock
					LDA	#$00
					STA	$1412
					LDA	$7FFFFB
					BEQ	EndRt
					LDA	#$00
					STA	$7FFFFB
					LDA	#$10
					STA	$190C
					PLB
					RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Leak:				JSR	L2AdressSwitch
					LDX	#$0B
Loop:				;LDA	#$01
					;STA $164A,x
					;DEX
					;BPL	Loop
					REP	#$20
					LDA	$1C
					SEC
					SBC	$1888
					SEC
					SBC	[$02]
					PHA
					CMP	#$0009
					SEP	#$20
					BCC	LeakOn
LeakOff:			LDA	#$01
					STA	$14AF
					PLA
					PLA
					RTS
LeakOn:				STZ	$14AF
					LDA	$1DFA
					BNE	LeakOn2
					LDA	$14
					AND #$3F
					LSR
					LSR
					TAY
					LDA SoundData,y
					STA $1DFA
LeakOn2:			REP	#$20
					PLA
					CMP	#$0004
					SEP	#$20
					BCS	NotStrike
					LDA	$75
					BEQ	NotStrike
					JSL $00F5B7
NotStrike:			RTS
SoundData:			db  $00,$04,$00,$00,$00,$04,$00,$00,$04,$00,$04,$00,$04,$00,$00,$04
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FrameCount:			LDA $14
					AND	#$03
					BNE	Return
					LDA	$7FFFFB
					BEQ	Return
					DEC
					STA	$7FFFFB
					BEQ	SwitchReset
					CMP	#$1D
					BNE	Return
Aleat:				LDA	#$24
					STA	$1DFC
Return:				RTS
SwitchReset:		LDA	$14AD
					BNE	Return
					LDA	$0DDA               
					BMI	Return
					STA	$1DFB
					STZ	$190C
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
L2Scroll:		JSR	L2AdressSwitch
				LDA	$7FFFFB
				BEQ	L2Scroll2
				LDA	#$60		;Down
L2Scroll2:		STA	$00
				STZ	$01
				REP	#$20
				LDA	$1C
				SEC
				SBC	$1888
				SEC
				SBC	[$02]
				PHA
				CLC
				ADC	#$0100
				STA	$7FFFF4
				PLA
				CMP	$00
				BEQ	L2ScrollReturn
				LDA	$14
				AND	#$0001
				BNE	L2ScrollReturn
				LDA	$00
				BNE	L2ScrollDown
				INC	$1468
				BRA	L2ScrollReturn
L2ScrollDown:	DEC	$1468
L2ScrollReturn:	SEP	#$20
				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
L2AdressSwitch:	LDA	$7FFFFE
				BNE	L2AdressSwitchA
				LDA	#$7E
				LDX	#$14
				LDY	#$68
				BRA	L2AdressSwitch2
L2AdressSwitchA:
				LDA	#$7F
				LDX	#$FF
				LDY	#$F0
L2AdressSwitch2:
				STA	$04
				STX	$03
				STY	$02
				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    

DATA_00F69F:	db $64,$00,$7C,$00

DATA_00F6A3:	db $00,$00,$FF,$FF

DATA_00F6A7:	db $FD,$FF,$05,$00,$FA,$FF

DATA_00F6AD2:	db $00,$00
DATA_00F6AD:	db $00,$00,$C0,$00,$00,$00

L2Fix:			LDA	$7FFFFE
				BEQ	Lb1
				DEC
				STA	$7FFFFE
				REP	#$20
				LDA	$1468
				SEC
				SBC	$7FFFF2
				CLC
				ADC	$7FFFF0
				STA	$1468
Lb1:			REP	#$20
				STZ	$00
				LDA	$13F1
				STA	$06
				LDA	$1C
				SEC
				SBC	$1888
				STA	$08
				LDA	#$00C0
				STA	$0A
				;LDA $5F                   
				;DEC A                     
				;XBA
				;AND	#$FF00

				STA	$04
				LDY	#$00
				LDA	$96
				SEC
				SBC	$08
				CMP	#$0070
				BMI	ScreenUpper
				LDY	#$02
ScreenUpper:	SEC                       
				SBC	DATA_00F69F,Y       
				STA	$02                   
				EOR	DATA_00F6A3,Y       
				BMI	CODE_00F81F
				LDY	#$02
				STZ	$02                   
CODE_00F81F:	LDA $02
				BPL CODE_00F883
	
CODE_00F82A:	SEP #$20
				LDA	$13E3
				CMP	#$06                
				BCS	CODE_00F845           
				LDA	$1410
				LSR
				ORA	$149F               
				ORA $74
				ORA	$13F3               
				ORA	$18C2               
				ORA	$1406 
CODE_00F845:	TAX                       
				REP #$20
				BNE CODE_00F869
				LDX	$187A
				BEQ CODE_00F856           
				LDX	$141E
				CPX	#$02
				BCS CODE_00F869
CODE_00F856:	LDX $75
				BEQ CODE_00F85E           
				LDX $72
				BNE	CODE_00F869           
CODE_00F85E:	LDX	$1412               
				DEX
				BEQ CODE_00F875           
				LDX	$06
				BNE CODE_00F875           
CODE_00F869:	STX	$06
				LDX	$06
				BNE CODE_00F881           
				LDY	#$04
				BRA CODE_00F881

CODE_00F875:	LDX	$1404               
				BNE CODE_00F881           
				LDX	$72
				BNE	L2FixReturn

CODE_00F881:	LDA $02
CODE_00F883:	SEC
				SBC	DATA_00F6A7,y
				EOR	DATA_00F6A7,y
				ASL
				LDA $02
				BCS CODE_00F892
				LDA	DATA_00F6A7,y
CODE_00F892:	STA	$00
				CLC
				ADC $08    
				PHA
				CMP	#$00C0
				BCC	CODE_00F89D
				LDA	DATA_00F6AD,y
				SEC
				SBC	$08
				STA	$00
CODE_00F89D:	PLA
				CMP	DATA_00F6AD2,y
				BPL	CODE_00F89D2
				LDA	DATA_00F6AD2,y
CODE_00F89D2:	STA $08
L2Slide:		LDA	$00
				CLC
				ADC	$1468
				STA	$1468
L2FixReturn:	LDA	$08
				SEC
				SBC	$1468
				STA	$04
				LDA	$08
				SEC
				SBC	$04
				SEC
				SBC	#$0010
				BPL L2FixReturn2
				LDA	$1468
				STA	$7FFFF0
				LDA	#$0010
				STA	$1468
				STA	$7FFFF2
				SEP	#$20
				LDA	#$01
				STA	$7FFFFE
L2FixReturn2:	SEP	#$20
				RTS